<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: models/product.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: models/product.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * @classdesc The product class
 *
 * @name Product
 * @class
 */

class Product {

    static defaultPriceDown = 1;
    static defaultDaysToDown = 1;
    static maxPrice = 50;
    /**
     * Create a Product.
     * @param {string} name - The name of product.
     * @param {number} sellIn - The limit of day to sell.
     * @param {number} price - The product price.
     */
    
    constructor(name, sellIn, price) {
      this.name = name;
      this.sellIn = sellIn;
      this.price = price;
      this.checkPrice();
    }

    /**
     * @function update 
     * @description call to update price and sellIn
    */

    update() {
        this.setPrice();
        this.setSellIn();
    }

    /**
     * @function setPrice 
     * @description update price to the default price to go down and if the sell in variable is less than 0, it degrade twice more fast.
     */

    setPrice(){
        if (this.sellIn &lt;= 0) {
            this.price = this.price - (Product.defaultPriceDown * 2);
        } else {
            this.price = this.price - Product.defaultPriceDown ;
        }
        this.checkPrice();
    }

    /**
     * @function setSellIn 
     * @description update day limit of sell
    */

    setSellIn(){
        this.sellIn = this.sellIn - Product.defaultDaysToDown;
    }
    
    /**
     * @function checkPrice 
     * @description check the price when the price is more than max Price, it degrade to max Price and if it is less tna 0, it set to 0. 
    */

    checkPrice() {
        if (this.price >= Product.maxPrice) this.price = 50;
        if (this.price &lt;= 0) this.price = 0;
      }

  }
  
  
  module.exports = Product;</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-Application.html">Application</a></li><li><a href="module-productController.html">productController</a></li></ul><h3>Classes</h3><ul><li><a href="carInsurance.html">carInsurance</a></li><li><a href="FullCoverage.html">FullCoverage</a></li><li><a href="LowCoverage.html">LowCoverage</a></li><li><a href="MediumCoverage.html">MediumCoverage</a></li><li><a href="MegaCoverage.html">MegaCoverage</a></li><li><a href="Product.html">Product</a></li><li><a href="specialFullCoverage.html">specialFullCoverage</a></li><li><a href="SuperSaleCoverage.html">SuperSaleCoverage</a></li></ul><h3>Global</h3><ul><li><a href="global.html#checkPrice">checkPrice</a></li><li><a href="global.html#getProducts">getProducts</a></li><li><a href="global.html#setPrice">setPrice</a></li><li><a href="global.html#setSellIn">setSellIn</a></li><li><a href="global.html#update">update</a></li><li><a href="global.html#updatePrice">updatePrice</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.6</a> on Sun Jan 24 2021 14:28:26 GMT-0600 (Central Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
